UseHVG2 <- function(data) {
  #!generates pseudo qVal by just using the variance
  st <- system.time({
    re <- data.frame(row.names = rownames(data))
    var1 <- apply(data, 1, var)
    mean_expr = apply(data, 1, function(x)
      mean(x[x != 0]))
    score <- log10(var1 / mean_expr)
    #re$score <- score
    #re$qVal <- 1-score/max(score)
    
    names(score) <- rownames(data)
    mean_score = mean(score)
    sd_score = sd(score)
    zs_score = (score - mean_score) / sd_score
    names(zs_score) = names(score)
    
    zs_ranked = zs_score[order(-zs_score)]
    
  })
  return(list(
    "zs_ranked" = zs_ranked,
    "genes" = names(zs_ranked),
    "time" = st
  ))
}


# UseHVG2_old <- function(data){
#
#     st <- system.time({
#         #!generates pseudo qVal by just using the variance
#         re <- data.frame(row.names = rownames(data))
#         var1 <- apply(data,1,var)
#         mean1 <- apply(data,1,mean)
#         score <- log10(var1/mean1)
#         re$score <- score
#         re$qVal <- 1-score/max(score)
#     })
#     # res <- list("p.adj" = re$qVal)
#     p.adj = re$qVal
#     names(p.adj) <- rownames(re)
#     p.adj <- sort(p.adj)
#     genes <- names(p.adj)
#
#     return(list("p.adj" = p.adj, "genes" = genes, "time" = st))
# }
